
#define  BUFSIZE  60000l

#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <conio.h>
#include <string.h>
#include <fcntl.h>
#include <dir.h>
#include <process.h>
#include <stdlib.h>
#include <alloc.h>
#include <mem.h>
#include <bios.h>

/* ------------------------------------------------- */

extern  unsigned char   _osmajor;

void        init_program(int argc, char *argv[]);
unsigned    make_file_list(void);
int         sort_list(void **f1, void **f2);
void        diskette_prompt(void);
long        smallest_file(void);
long        space_left(void);
void        copy_a_file(void);
void        done_program(void);
char        *filefind(void);
int         int24handler(int, int, int, int);

/* ------------------------------------------------- */

struct  filedata
        {
        char    filename[13];
        long    filesize;
        char    done;
        };

/* ------------------------------------------------- */

char    far     *olddta;
struct  ffblk   dos_find_blk;
char            *buffer;
char            filepattern[MAXPATH];

char            drive[MAXDRIVE];
char            dirs[MAXDIR];
char            filename[MAXFILE];
char            ext[MAXEXT];
char            filepattern[MAXPATH];
char            targetdrive[MAXDRIVE];

struct filedata *filelist[2000];

short int       files_copied;
short int       firsttime;
short int       filecount;
short int       disk_count;
short int       files_left;
long            amt_left;

short int       reset_time_flag;
short int       arg_hours;
short int       arg_minutes;
short int       arg_seconds;

union    REGS   inregs, outregs;
struct   SREGS  *segs;

int             zero = 0;
int             one  = 1;
int             two  = 2;
int             files_this_diskette;

struct  {
        char        first_byte;
        char        junk1 [2];
        char        oem_name [8];
        unsigned    bytes_sector;
        char        sectors_cluster;
        unsigned    reserved_sectors;
        char        fat_count;
        unsigned    root_entries;
        unsigned    sectors_media;
        char        media_descriptor;
        unsigned    sectors_fat;
        unsigned    sectors_track;
        unsigned    head_count;
        unsigned    hidden_sectors;
        char        junk2 [482];
        } 
    boot_sector;



/* ------------------------------------------------- */

void    main(int argc, char *argv[])
        {

        init_program(argc, argv);
        filecount = make_file_list();
        files_left = filecount;
        qsort(filelist, filecount, 4, sort_list);

        printf("\n\nA total of %d files will be copied.\n\n", filecount);

next_disk:
        diskette_prompt();
        files_this_diskette = 5;
        amt_left = space_left();

        while (files_copied < filecount 
            && smallest_file() < amt_left
            && files_this_diskette < boot_sector.root_entries)
                {
                copy_a_file();
                files_copied++;
                files_this_diskette++;
                files_left--;
                amt_left = space_left();
                }

        if (files_copied < filecount)
            {
            goto next_disk;
            }

        done_program();
        }

/* ------------------------------------------------- */

void    init_program(int argc, char *argv[])
        {
        harderr(int24handler);
        _fmode  = O_BINARY;

        files_copied = 0;
        disk_count = 0;

        buffer = (char *) malloc( (unsigned) BUFSIZE);
        if (buffer == NULL)
            {
            printf("Error.  No memory for buffer.\n");
            exit(1);
            }
        if (argc < 3)
            {
            printf("Usage: DCOPY <filespec> <drive:> (e.g., 'dcopy *.* a:')\n");
            exit(1);
            }
        if ((strlen(argv[2]) != 2) || (argv[2] [1] != ':'))
            {
            printf("Error.  Target drive is invalid.\n");
            exit(1);
            }

        strcpy(filepattern, argv[1]);
        strcpy(targetdrive, argv[2]);
        strupr(targetdrive);
        fnsplit(argv[1], drive, dirs, filename, ext);

        if (strlen(drive) == 0)
            {
            drive[0] = (char) getdisk() + 'A';
            drive[1] = ':';
            drive[2] = '\0';
            }

        strupr(drive);
        if (strcmp(drive, targetdrive) == 0)
            {
            printf("Error.  Source and target must be different.\n");
            exit(1);
            }

        reset_time_flag = 0;
        if (argc > 3)
            {
            reset_time_flag = 1;
            arg_hours = atoi(argv[3]);
            if (argc > 4)
                {
                arg_minutes = atoi(argv[4]);
                if (argc > 5)
                   {
                   arg_seconds = atoi(argv[5]);
                   }
                }
            }

        }

/* ------------------------------------------------- */

unsigned     make_file_list()
        {
        char            *nextfile;
        unsigned        fcount;

        fcount = 0;
next_dir_entry:
        nextfile = filefind();
        if (nextfile != NULL)
            {
            filelist[fcount] 
                = (struct filedata *) malloc(sizeof(struct filedata));
            if (filelist[fcount] == NULL)
                {
                printf("Out of memory!\n");
                exit(1);
                }
            strcpy(filelist[fcount]->filename, nextfile);
            filelist[fcount]->filesize = dos_find_blk.ff_fsize;
            filelist[fcount]->done = 0;
            fcount++;
            goto next_dir_entry;
            }
        return(fcount);
        }

/* ------------------------------------------------- */

int     sort_list(void **f1, void **f2) 
        {
        if ( ((struct filedata *) *f1)->filesize > 
                ((struct filedata *) *f2)->filesize) return(-1);
        if ( ((struct filedata *) *f1)->filesize < 
                ((struct filedata *) *f2)->filesize) return(1);
        return(0);
        }

/* ------------------------------------------------- */

void    diskette_prompt()
        {
        int  ch;

        disk_count++;
dp_10:
        printf("\nPut diskette in drive %s.", targetdrive);
        printf(" (disk number %d).  %d files remain.\n",disk_count,files_left);
        printf("Press Enter when the diskette is ready. (Esc to quit): ");
        ch = getch();
        if (ch == 27)
            exit(0);

        if (absread(targetdrive[0]-'A', 1, 0, &boot_sector) == -1)
            goto dp_10;

        printf("\n\nDiskette root directory size is %d files.\n", boot_sector.root_entries);
        }

/* ------------------------------------------------- */

long    smallest_file()
        {
        int i;
        long j;

        j = 999999999l;
        for (i=0; i<filecount; i++)
            {
            if ((filelist[i]->filesize < j) && (filelist[i]->done == 0))
                {
                j = filelist[i]->filesize;
                }
            }
        return(j);
        }

/* ------------------------------------------------- */

long    space_left()
        {
        struct  dfree diskdata;
        long    clusters, sectors, bytes;

        getdfree( (int) ((targetdrive[0]-'A')+1), &diskdata);
        clusters = (long) diskdata.df_avail;
        sectors  = (long) diskdata.df_bsec;
        bytes    = (long) diskdata.df_sclus;
        return(clusters * sectors * bytes);
        }

/* ------------------------------------------------- */

void    copy_a_file()
        {
        int      i;
        char     source[MAXPATH];
        char     dest[MAXPATH];
        int      fhin, fhout;
        unsigned bytecount;
        struct   ftime ftimestruc;

        i = 0;

nxtfile:
        if (i > filecount)
            {
            printf("\nERROR!  No files fit anywhere!\n\n");
            exit(1);
            }

        if (filelist[i]->done == 1 || filelist[i]->filesize > amt_left)
            {
            i++;
            goto nxtfile;
            }

        fnmerge(dest, targetdrive, NULL, filelist[i]->filename, NULL);
        fnmerge(source, drive, dirs, filelist[i]->filename, NULL);

        fhin = open(source, O_RDONLY);
        if (fhin < 1)
            {
            printf("Internal Error (1).\n");
            exit(1);
            }
        fhout= _creat(dest, 0);
        if (fhout < 1)
            {
            printf("Internal Error (2).\n");
            exit(1);
            }

        printf("%-16s", filelist[i]->filename);

nxtblk:
        bytecount = read(fhin, buffer, (unsigned) BUFSIZE);
        if (bytecount == 0)
            goto copy_done;

        write(fhout, buffer, bytecount);
        goto nxtblk;

copy_done:
        if (reset_time_flag == 0)
            {
            getftime(fhin, &ftimestruc);
            setftime(fhout,&ftimestruc);
            }
        else
            {
            ftimestruc.ft_hour = arg_hours;
            ftimestruc.ft_min  = arg_minutes;
            ftimestruc.ft_tsec = arg_seconds;
            setftime(fhout,&ftimestruc);
            }

        _close(fhin);
        _close(fhout);
        filelist[i]->done = 1;
        }

/* ------------------------------------------------- */

void    done_program()
        {
        printf("\n\n%d files were copied.\n\n", files_copied);
        }

/* ------------------------------------------------- */

char    *filefind()
        {

        olddta = getdta();

        if (firsttime) goto getnextblk;

        firsttime = 1;
        if (findfirst(filepattern, (struct ffblk *) &dos_find_blk, 0) != 0)
           {
            setdta(olddta);
            return(NULL);
           }

        setdta(olddta);
        return(dos_find_blk.ff_name);

getnextblk:
        if (findnext( (struct ffblk *) &dos_find_blk) != 0)
           {
            setdta(olddta);
            return(NULL);
           }

        setdta(olddta);
        return(dos_find_blk.ff_name);

        }


/* ------------------------------------------------- */

int     int24handler(int errval, int ax, int bp, int si)

        {
        char    msg[25];
        int     drive;
        int     k;

        if (ax < 0)
            {
            bdosptr(0x09, "\nDevice error has occurred!\n$", 0);
            bdosptr(0x09, "Attempting to recover....\n$", 0);
            hardretn(-1);
            }

        drive = (ax & 0x00FF);
        sprintf(msg, "SERIOUS! I/O error on disk drive %c.$", 'A' + drive);
        bdosptr(0x09, msg, 0);
        bdosptr(0x09, "  Press a key to continue (q to quit).  $", 0);
        k = bioskey(0);
        if (k == 'q' || k == 'Q')
            {
            return(2);
            }
        bdosptr(0x09, "\n\nAttempting to recover....\n$", 0);
        hardretn(-1);
        }

/* ------------------------------------------------- */


